import Globals
from Globals import HTMLFile

from Document import Document
from Discussions import DiscussionResponse

def addDiscussionItem(self, id, title, description, text_format, text,
                      reply_to, RESPONSE=None):
    """
    Add a discussion item

    'title' is also used as the subject header
    if 'description' is blank, it is filled with the contents of 'title'
    'reply_to' is the object (or path to the object) which this is a reply to

    Otherwise, same as addDocument
    """

    if not description: description = title
        
    item = DiscussionItem()
    item.id = id
    item.title = title
    item.description = description
    item.text_format = text_format
    item.text = text
    item.setReplyTo(reply_to)

    item._parse()
    self._setObject(id, item)

    # Replies should default to published
    self[id]._review_action('posted', 'published', '', self.REQUEST)
    
    if RESPONSE is not None:
        RESPONSE.redirect(self.absolute_url())

    
class DiscussionItem(DiscussionResponse, Document):
    """
    This is the PortalContent object for content which is a response to other
    content.
    """

    __ac_permissions__ = (
        ('Change Discussion Items', ('edit',), ('Owner',)),
        )

    index_html = HTMLFile('dtml/discussionView',globals())

    editForm = HTMLFile('dtml/discussionEdit',globals())

    def edit(self, title, description, text_format, text, file='', REQUEST=None):
        """
        Edit the discussion item.
        """

        if not description: description = title
        
        Document.edit(self, title, description, text_format, text, file)
        if REQUEST is not None:
            return self.editForm(self, REQUEST,
                              portal_status_message='Discussion item changed.')

Globals.default__class_init__(DiscussionItem)

from Products.PTKBase.register import registerPortalContent
registerPortalContent(DiscussionItem,
                      constructors=(addDiscussionItem,),
                      action="",
                      icon="discussionitem.gif")
