import Rack, Specialists

def initialize(context):

    context.registerPlugInClass(
        Rack.Rack,
        permission = 'Add Racks',
        constructors = (Rack.manage_addRackForm,
                        Rack.manage_addRack),
        icon = 'www/rack.gif',
    )
                                                                
    context.registerClass(
        Specialists.Specialist,
        permission = 'Add Specialists',
        constructors = (Specialists.manage_addSpecialistForm,
                        Specialists.manage_addSpecialist),
        icon = 'www/specialist.gif',
    )
                                                                
    context.registerPlugInClass(
        AttributeProviders.AttributeProvider,
        permission = 'Add Attribute Providers',
        constructors = (AttributeProviders.manage_addAttributeProviderForm,
                        AttributeProviders.manage_addAttributeProvider),
#        icon = 'www/rack.gif',
    )
                                                                
    context.registerPlugInClass(
        AttributeProviders.AcquiredAttributeProvider,
        permission = 'Add Acquired Attribute Providers',
        constructors = (AttributeProviders.manage_addAcquiredAttributeProviderForm,
                        AttributeProviders.manage_addAcquiredAttributeProvider),
#        icon = 'www/rack.gif',
    )
                                                                
    context.registerPlugInClass(
        SheetProviders.SheetProvider,
        permission = 'Add Sheet Providers',
        constructors = (SheetProviders.manage_addSheetProviderForm,
                        SheetProviders.manage_addSheetProvider),
#        icon = 'www/rack.gif',
    )
                                                                
    context.registerPlugInClass(
        SheetProviders.AcquiredSheetProvider,
        permission = 'Add Acquired Sheet Providers',
        constructors = (SheetProviders.manage_addAcquiredSheetProviderForm,
                        SheetProviders.manage_addAcquiredSheetProvider),
#        icon = 'www/rack.gif',
    )
                                                                
    context.registerBaseClass(Rack.Rack)
    context.registerBaseClass(Rack.RackMountable)
    context.registerBaseClass(Specialists.Specialist)

    if hasattr(context,'registerHelp'):
        context.registerHelp()


# The only way to register extra permissions for a ZClass base at present
# Waaaa
__ac_permissions__ = (
    ('Delete rack-mounted objects', ()),
)
